<?php

namespace Drupal\mdp\Plugin\Field;

use Drupal\Core\Field\FieldItemList;

/**
 * Custom field item list class for MDPItem.
 */
class MDPItemList extends FieldItemList {

  /**
   * {@inheritdoc}
   */
  public function setValue($values, $notify = TRUE) {
    if (is_string($values)) {
      $separator = $this->getDataDefinition()->getSettings()['separator'];
      $values = array_map('trim', explode($separator, $values));
      $values = array_map(function ($value) {
        return ['value' => $value];
      }, $values);
    }
    parent::setValue($values, $notify);
  }

  /**
   * {@inheritdoc}
   */
  public function getValue() {
    $separator = $this->getDataDefinition()->getSettings()['separator'];
    // Optional: Returns values as a comma-separated string.
    return implode($separator, array_column(parent::getValue(), 'value'));
  }

}
